diff mbox series

[1/2] scripts/makefile-getvar: add script to get values from Makefiles

Message ID 20240612110659.2750133-1-ross.burton@arm.com
State New
Headers show
Series [1/2] scripts/makefile-getvar: add script to get values from Makefiles | expand

Commit Message

Ross Burton June 12, 2024, 11:06 a.m. UTC
There is often a need to extract a value from a Makefile, and standard
GNU Make doesn't provide a way to do this.  This script lets you access
values from Makefiles directly:

$ makefile-getvar curl/tests/server/Makefile noinst_PROGRAMS
getpart resolve rtspd sockfilt sws tftpd fake_ntlm socksd disabled mqttd

Signed-off-by: Ross Burton <ross.burton@arm.com>
---
 scripts/makefile-getvar | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)
 create mode 100755 scripts/makefile-getvar
diff mbox series

Patch

diff --git a/scripts/makefile-getvar b/scripts/makefile-getvar
new file mode 100755
index 00000000000..4a07055e687
--- /dev/null
+++ b/scripts/makefile-getvar
@@ -0,0 +1,24 @@ 
+#! /bin/sh
+
+# Get a variable's value from a makefile:
+#
+# $ makefile-getvar Makefile VARIABLE VARIABLE ...
+#
+# If multiple variables are specified, they will be printed one per line.
+#
+# SPDX-FileCopyrightText: Copyright 2024 Arm Limited and/or its affiliates <open-source-office@arm.com>
+# SPDX-License-Identifier: GPL-2.0-only
+
+set -eu
+
+MAKEFILE=$1
+shift
+
+for VARIABLE in $*; do
+	make -f - $VARIABLE.var <<EOF
+include $MAKEFILE
+
+%.var:
+	@echo \$(\$*)
+EOF
+done